/*
  Copyright (c) 2009 Sascha Steinbiss <steinbiss@zbh.uni-hamburg.de>
  Copyright (c) 2009 Center for Bioinformatics, University of Hamburg

  Permission to use, copy, modify, and distribute this software for any
  purpose with or without fee is hereby granted, provided that the above
  copyright notice and this permission notice appear in all copies.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef SCRIPT_WRAPPER_VISITOR_API_H
#define SCRIPT_WRAPPER_VISITOR_API_H

/* Implements the <GtNodeVisitor> interface. */
typedef struct GtScriptWrapperVisitor GtScriptWrapperVisitor;

#include "extended/node_visitor_api.h"

typedef void (*GtScriptWrapperVisitorFreeFunc)(GtNodeVisitor*);
typedef int  (*GtScriptWrapperVisitorCommentNodeFunc)(GtCommentNode*,
                                                      GtError*);
typedef int  (*GtScriptWrapperVisitorFeatureNodeFunc)(GtFeatureNode*,
                                                      GtError*);
typedef int  (*GtScriptWrapperVisitorRegionNodeFunc)(GtRegionNode*,
                                                     GtError*);
typedef int  (*GtScriptWrapperVisitorSequenceNodeFunc)(GtSequenceNode*,
                                                       GtError*);
typedef int  (*GtScriptWrapperVisitorMetaNodeFunc)(GtMetaNode*,
                                                   GtError*);
typedef int  (*GtScriptWrapperVisitorEOFNodeFunc)(GtEOFNode*,
                                                  GtError*);

/* Creates a new <GtScriptWrapperVisitor> for a number of callback functions. */
GtNodeVisitor* gt_script_wrapper_visitor_new(
                                         GtScriptWrapperVisitorCommentNodeFunc,
                                         GtScriptWrapperVisitorFeatureNodeFunc,
                                         GtScriptWrapperVisitorRegionNodeFunc,
                                         GtScriptWrapperVisitorSequenceNodeFunc,
                                         GtScriptWrapperVisitorMetaNodeFunc,
                                         GtScriptWrapperVisitorEOFNodeFunc,
                                         GtScriptWrapperVisitorFreeFunc);

#endif
